<template>
  <view-list
    v-on:model-reload="loadList"
    v-on:export-csv="downloadCsv"
    v-on:model-search="search($event.query, $event.field)"
    :status="status"
    title="Operacje"
    :button="true"
    button_link="/operacje/nowa"
    button_title="Dodaj nową operację"
    :length="filteredData.length"
  >
    <RecycleScroller :items="filteredData" :item-size="143" v-if="renderHack">
      <template v-slot="{ item }">
        <action-list-item v-bind="item" />
      </template>
    </RecycleScroller>
  </view-list>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";

import ViewList from "@/views/list-views/ViewList.vue";
import ActionListItem from "@/components/list/custom/ActionListItem.vue";

import { ActionData, CsvDownload, ItemData, LoadingState } from "@/interfaces";
import RecordList from "@/views/list-views/RecordList";
import { NApi } from "@/interfaces/connector";
import Fuse from "fuse.js";

@Options({
  components: {
    ViewList,
    ActionListItem,
  },
  computed: ["filteredActions"],
})
export default class Actions extends RecordList<ActionData> {
  public API_CALL = NApi.getActions;

  async downloadCsv() {
    const temp: any[] = JSON.parse(JSON.stringify(this.filteredData));

    for (let i = 0; i < temp.length; i++) {
      temp[i].to = temp[i].to != undefined ? temp[i].to.id : null;
      temp[i].from = temp[i].from != undefined ? temp[i].from.id : null;
      temp[i].item = temp[i].item != undefined ? temp[i].item.id : null;
      temp[i].location =
        temp[i].location != undefined ? temp[i].location.id : null;
    }
    await new CsvDownload(" ; ").download(temp);
  }

  async onLoaded(data: ActionData[]) {
    const options = {
      includeScore: false,
      keys: [
        "description",
        "to.name",
        "to.surname",
        "to.email",
        "from.name",
        "from.surname",
        "from.email",
        "item.name",
        { name: "item.description", weight: 0.2 },
        "item.serial_number",
        "item.part_number",
        "location.name",
        "location.street",
        "location.post_code",
        "location.city",
      ],
    };

    this.rawData = data;
    this.fuseData = Object.freeze(new Fuse(data, options));
    this.filter();
  }
}
</script>
